#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define N 20
#define USLA 1
#define NIJE 0

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};
typedef struct kosevi{
	int prvi;
	int drugi;
	int treci;
	int cetvrti;
}Kosevi;
typedef struct poruka{
	long int tipPoruke;
	int tekstPoruke;
}Poruka;

Poruka mojaPoruka;
int idReda;

void handler(int sig){
	int pom;
	while(1){
		pom = rand()%4+1;
		if(pom !=3)
			break;
	}
	mojaPoruka.tipPoruke = pom;
	mojaPoruka.tekstPoruke = 1;
	msgsnd(idReda,&mojaPoruka,sizeof(mojaPoruka),0);
}


int main(){
	key_t key;
	int semid,shmid,ind;
	union semun arg;
	pid_t pid;
	struct sembuf PS,VS,PL,PK,VK,PR,VR,VL;
	int rbrKosa = 1,br=0;
	int niz = 0,pogodak;
	Kosevi *brKoseva;
	
	key = ftok("./prvi.c",'A');
	printf("Kljuc je %d\n",key);
	idReda = msgget(key,0666|IPC_CREAT);
	shmid = shmget(key,sizeof(Kosevi),0666|IPC_CREAT);
	printf("Shmid je %d\n",shmid);
	semid = semget(key,4,0666|IPC_CREAT|IPC_EXCL);
	if(semid != -1){
		printf("Ja sam kreirao semafor\n");
		arg.val = N;
		semctl(semid,0,SETVAL,arg);
		arg.val = 1;
		semctl(semid,1,SETVAL,arg);
		arg.val = 1;
		semctl(semid,2,SETVAL,arg);
		arg.val = 1;
		semctl(semid,3,SETVAL,arg);
	}
	else if(errno == EEXIST){
		printf("Neko je vec kreirao semafor ja se kacim\n");
		semid = semget(key,2,0);
	}
	else{
		printf("Greskaaa\n");
		exit(0);
	}
	
	PS.sem_num = 1;
	PS.sem_op = -1;
	PS.sem_flg = 0;
	
	VS.sem_num = 1;
	VS.sem_op = 1;
	VS.sem_flg = 0;
	
	PL.sem_num = 0;
	PL.sem_op = -1;
	PL.sem_flg = 0;
	
	VL.sem_num = 0;
	VL.sem_op = 1;
	VL.sem_flg = 0;
	
	PK.sem_num = 2;
	PK.sem_op = -1;
	PK.sem_flg = 0;
	
	VK.sem_num = 2;
	VK.sem_op = 1;
	VK.sem_flg = 0;
	
	PR.sem_num = 3;
	PR.sem_op = -1;
	PR.sem_flg = 0;
	
	VR.sem_num = 3;
	VR.sem_op = 1;
	VR.sem_flg = 0;
	
	brKoseva = (Kosevi *)shmat(shmid, NULL, 0);
	
	
	if((pid = fork()) != 0){
		while(1){
			rbrKosa = 3;
			ind = semop(semid,&PS,1);
			if(ind == -1){ printf("GRESKAA\n");break;}
			ind = semop(semid,&PL,1);
			if(ind == -1){ printf("GRESKAA\n");break;}
			sleep(1);
			ind = semop(semid,&VS,1);
			if(ind == -1){ printf("GRESKAA\n");break;}
			
			ind = msgrcv(idReda,&mojaPoruka,sizeof(mojaPoruka),3,IPC_NOWAIT);
			if(ind != -1){
				rbrKosa = mojaPoruka.tekstPoruke;
				printf("Pomazem igracu %d\n",rbrKosa);
			}
			sleep(3);
			pogodak = rand()%2;
			if(rbrKosa == 3){
				if(pogodak == USLA){
					br++;
					ind = semop(semid,&PK,1);
					if(ind == -1){ printf("GRESKAA\n");break;}
					printf("Pogodio sam svoj kos\n");
					brKoseva->treci++;
					ind = semop(semid,&VK,1);
					if(ind == -1){ printf("GRESKAA\n");break;}
					niz = 0;
				}
				else{
					niz--;
					printf("Omasio sam %d\n",niz);
				}
				if(niz == -2){
					kill(pid,SIGINT);
					niz = 0;
				}
			}
			else if(rbrKosa == 1){
				ind = semop(semid,&PK,1);
				if(ind == -1){ printf("GRESKAA\n");break;}
				if(pogodak == USLA){
				printf("Pogodio sam kos 1\n");
				brKoseva->prvi++;
				}
				ind = semop(semid,&VK,1);
				if(ind == -1){ printf("GRESKAA\n");break;}
			}
			else if(rbrKosa == 2){
				ind = semop(semid,&PK,1);
				if(ind == -1){ printf("GRESKAA\n");break;}
				if(pogodak == USLA){
				printf("Pogodio sam kos 2\n");
				brKoseva->drugi++;
				}
				ind = semop(semid,&VK,1);
				if(ind == -1){ printf("GRESKAA\n");break;}
			}
			else if(rbrKosa == 4){
				ind = semop(semid,&PK,1);
				if(ind == -1){ printf("GRESKAA\n");break;}
				if(pogodak == USLA){
				printf("Pogodio sam kos 4\n");
				brKoseva->cetvrti++;
				}
				ind = semop(semid,&VK,1);
				if(ind == -1){ printf("GRESKAA\n");break;}
			}	
			ind = semop(semid,&PR,1);
			if(ind == -1){ printf("GRESKAA\n");break;}	
			sleep(2);
			ind = semop(semid,&VR,1);
			if(ind == -1){ printf("GRESKAA\n");break;}
			ind = semop(semid,&VL,1);
			if(ind == -1){ printf("GRESKAA\n");break;}
		}
	}
	else{
		//DETE
		signal(SIGINT,handler);
		
		while(1){
			sleep(10);
			ind = semop(semid,&PK,1);
			if(ind == -1){ printf("GRESKAA\n");break;}
			printf("Broj koseva koji je %d\n",brKoseva->treci);
			ind = semop(semid,&VK,1);
			if(ind == -1){ printf("GRESKAA\n");break;}
		}
	}
	return 0;
}
