#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int *prvi_kos;
int *drugi_kos;
int *treci_kos;
int *cetvrti_kos;

union semun 
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

void signal_handler(int sig)
{
	printf("Kroz prvi kos: %d\n",*prvi_kos);
	printf("Kroz drugi kos: %d\n",*drugi_kos);
	printf("Kroz treci kos: %d\n",*treci_kos);
	printf("Kroz cetvrti kos: %d\n",*cetvrti_kos);
	
	shmdt(prvi_kos);
	shmdt(drugi_kos);
	shmdt(treci_kos);
	shmdt(cetvrti_kos);
	
	exit(0);
}


int main()
{
	srand(time(NULL));
	key_t kljuc;
	int id_sem,id_shm_kos1,id_shm_kos2,id_shm_kos3,id_shm_kos4,id_shm_stalak;
	int *broj_lopti;
	
	int pom,pom1,pom2;
	struct sembuf P,V,Q;
	
	signal(SIGINT,signal_handler);
	
	kljuc = ftok("igrac.c",100);
	id_shm_kos1 = shmget(kljuc,sizeof(int),IPC_CREAT|0666);
	kljuc = ftok("igrac.c",101);
	id_shm_kos2 = shmget(kljuc,sizeof(int),IPC_CREAT|0666);
	kljuc = ftok("igrac.c",102);
	id_shm_kos3 = shmget(kljuc,sizeof(int),IPC_CREAT|0666);
	kljuc = ftok("igrac.c",103);
	id_shm_kos4 = shmget(kljuc,sizeof(int),IPC_CREAT|0666);
	kljuc = ftok("igrac.c",104);
	id_shm_stalak = shmget(kljuc,sizeof(int),IPC_CREAT|0666);
	
	prvi_kos = shmat(id_shm_kos1,NULL,0); //Povezan prvi kos;
	drugi_kos = shmat(id_shm_kos2,NULL,0); //Povezan drugi kos;
	treci_kos = shmat(id_shm_kos3,NULL,0); //Povezan treci kos;
	cetvrti_kos = shmat(id_shm_kos4,NULL,0); //Povezan cetvrti kos;
	
	broj_lopti = shmat(id_shm_stalak,NULL,0); //Povezan stalak;
	
	kljuc = ftok("igrac.c",105);
	id_sem = semget(kljuc,2,IPC_CREAT|0666);
	
	P.sem_num = 0;
	P.sem_op = 1;
	P.sem_flg = 0;
	
	V.sem_num = 0;
	V.sem_op = -1;
	V.sem_flg = 0;
	
	Q.sem_num = 1;
	Q.sem_op = 1;
	Q.sem_flg = 0;
	
	while(1)
	{
		if (*broj_lopti > 0)  //Igrac uzima loptu sa stalka
		{
			printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n",0,id_sem,1);
			sleep(3);
			semop(id_sem,&V,1);  //Smanjuje semafor za jedan
			sleep(1);
			pom = *broj_lopti;   
			pom = pom - 1;
			*broj_lopti = pom;
			printf("Broj lopti: %d\n",*broj_lopti);
			printf("Povecavam semafor %d iz skupa %d za vrednost %d\n",0,id_sem,1);
			sleep(3);
			semop(id_sem,&P,1);  //Povecava semafor na 1 (da bi mogli drugi igraci da pristupe stalku)
		
			sleep(3);
			pom1 = rand() % 4 + 1;
			if (pom1 == 1)   //Sutira na prvi kos
			{
				printf("Prvi kos\n");
				pom2 = rand() % 2;
				if (pom2 == 1)  //Pogodak
				{
					printf("Pogodio sam!\n");
					*prvi_kos += 1;
				}
			}
			else if (pom1 == 2)  //Sutira na drugi kos
			{
				printf("Drugi kos\n");
				pom2 = rand() % 2;
				if (pom2 == 1)  //Pogodak
				{
					printf("Pogodio sam!\n");
					*drugi_kos += 1;
				}
			}
			else if (pom1 == 3)  //Sutira na treci kos
			{
				printf("Treci kos\n");
				pom2 = rand() % 2;
				if (pom2 == 1)  //Pogodak
				{
					printf("Pogodio sam!\n");
					*treci_kos += 1;
				}
			}
			else  //Sutira na cetvrti kos
			{
				printf("Cetvrti kos\n");
				pom2 = rand() % 2;
				if (pom2 == 1)  //Pogodak
				{
					printf("Pogodio sam!\n");
					*cetvrti_kos += 1;
				}
			}
			printf("Povecavam semafor %d iz skupa %d za vrednost %d\n",1,id_sem,1);
			sleep(3);
			semop(id_sem,&Q,1);  
		}
	}
	
	shmdt(broj_lopti);
	
	return 0;
}
