#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid;
int broj_lopti_kos[4];


void izbrisiSemafor(int sig)
{
	int i;
	for(i=0;i<4;i++)
		printf("Broj lopti u %d. kosu je %d\n",i+1,broj_lopti_kos[i]);
	printf("Prekinut proces, brisem semafore\n");
	semctl(semid,0,IPC_RMID); //prva tri semafora kosevi, cetvrti stalak
	semctl(semid,1,IPC_RMID);
	semctl(semid,2,IPC_RMID);
	semctl(semid,3,IPC_RMID);
	semctl(semid,4,IPC_RMID);
	printf("Zavrsavam..\n");
	exit(0);
}

int main()
{
	int i;
	srand(time(NULL));
	union semun operacija;
	struct sembuf P,V; //za stalak
	struct sembuf P1,V1; //za kos
	
	for(i=0;i<4;i++)
		broj_lopti_kos[i]=0;
	
	key_t key;
	int shmid;
	key=ftok("./igrac.c",'V');
	shmid=shmget(key,sizeof(int),0644|IPC_CREAT);
	
	int *br_lopti;
	br_lopti=shmat(shmid,NULL,0);
	
	key=ftok("./igrac.c",'T');
	int shmid1;
	shmid1=shmget(key,4*sizeof(int*),0644|IPC_CREAT);
	*broj_lopti_kos=shmat(shmid1,NULL,0);

	key=ftok("./igrac.c",'P');
	
	int semid;
	semid=semget(key,5,0644|IPC_CREAT|IPC_EXCL);
	
	signal(SIGINT,izbrisiSemafor);
	
	if(semid!=-1)
	{
		operacija.val=1;
		semctl(semid,0,SETVAL,operacija);
		semctl(semid,1,SETVAL,operacija);
		semctl(semid,2,SETVAL,operacija);
		semctl(semid,3,SETVAL,operacija);
		
		operacija.val=1;
		semctl(semid,4,SETVAL,operacija);
	}
	else if(errno==EEXIST)
	{
		printf("Semafor je kreiran i inicijalizovan, ja se samo povezujem\n");
		semid=semget(key,5,0);
	}
	else
	{
		printf("Neka druga greska\n");
		exit(1);
	}
	
	
	P.sem_num=4;
	P.sem_op=-1;
	P.sem_flg=0;
	
	V.sem_num=4;
	V.sem_op=1;
	V.sem_flg=0;
	 //Igrac uzima loptu
	semop(semid,&P,1);
	if(*br_lopti>0){
		*br_lopti=*br_lopti-1;
		sleep(1);}
	semop(semid,&V,1);
	
	//Igrac odredjuje na koji kos baca loptu
	int br;
	br=rand()%4;
	
	P1.sem_num=br;
	P1.sem_op=-1;
	P1.sem_flg=0;
	
	V1.sem_num=br;
	V1.sem_op=1;
	V1.sem_flg=0;
	
	int kos; //da li je lopta usla u kos, 0-nije, 1-jeste
	//Igrac baca loptu u kos
	semop(semid,&P1,1);
	sleep(3);
	kos=rand()%2;
	if(kos==1)
		broj_lopti_kos[i]++;
	semop(semid,&V1,1);
	
	
	
	
	shmdt(br_lopti);
	shmdt(broj_lopti_kos);
	return 0;
}
