#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define POGODIO 0
#define PROMASIO 1

#define POZIV_ZA_POMOC 1

//int brojubacenih;

union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

void signalhandler(int signal)
{
	//salje poruku za pomoc
	printf("Saljem poruku za pomoc\n");
}

struct STALAK
{
	int ukupanbrojlopti;
	int naraspolaganju;
};

struct msg
{
	long tip;
	int brojubacenih;
};

int main(int argc, char **argv)
{
	srand(time(NULL));
	
	key_t key=ftok("./igrac.c",'A');
	int shmid=shmget(key,1024,0666|IPC_CREAT);
	
	key=ftok("./igrac.c",'C');
		int id_reda=msgget(key,0666|IPC_CREAT);
	
	key=ftok("./igrac",'B');
	int semid=semget(key,2,0666|IPC_CREAT|IPC_EXCL); //broj semafora?
	
	struct STALAK *stalak;
	union semun arg;
	
	struct msg poruka;
	poruka.tip=1;
	poruka.brojubacenih=0;
	
	int rednibrojkosa=atoi(argv[1]);
	//brojubacenih=0;
	int pogodio_promasio=0;
	
	struct sembuf semaforP,semaforV, redarV;
	int ind=0;
	int pom;
	//printf("%d\n",brojkosa);
	
	if(semid!=-1)
	{
		//radi samo prvi igrac koji pravi sve
		int n;
		printf("Koliko ima lopti?");
		scanf("%d",&n);
		
		stalak=shmat(shmid,NULL,0);
		
		stalak->ukupanbrojlopti=n;
		stalak->naraspolaganju=n;
		//stalak
		arg.val=n;//toliko imam lopti koje mogu da se koriste
		semctl(semid,0,SETVAL,arg);
		
		arg.val=0;
		semctl(semid,1,SETVAL,arg);//redar, cim se sutira redar vraca loptu

	}
	else if(errno==EEXIST)
	{
		semid=semget(key,2,0); //broj semafora?
	}
	else
	{
		printf("Doslo je do greske\n");
		exit(1);
	}
	
	
	semaforP.sem_num=0;
	semaforP.sem_op=-1;
	semaforP.sem_flg=0;
	
	semaforV.sem_num=0;
	semaforV.sem_op=+1;
	semaforV.sem_flg=0;
	
	redarV.sem_num=1;
	redarV.sem_op=+1;
	redarV.sem_flg=0;
	
	int pid=fork();
	
	if(pid==0)//dete,statistika
	{
		/*
		key=ftok("./igrac.c",'C');
		int id_reda=msgget(key,0);
		*/
		//printf("Dete %d\n",id_reda);
		/*
		poruka.tip=1;
		poruka.brojubacenih=0;
		*/
		signal(SIGINT,signalhandler);
		while(1)
		{
			//prima da li je ubacio u kos
			sleep(10);
			msgrcv(id_reda,&poruka,sizeof(poruka),1,IPC_NOWAIT);
			printf("Ubacio sam %d lopti\n",poruka.brojubacenih);
		}
	}
	 if(pid==-1)
	{
		printf("Greska pri forkovanju\n");
		exit(1);
	}
	else //roditelj
	{
		/*
		key=ftok("./igrac.c",'C');
		int id_reda=msgget(key,0666|IPC_CREAT);
		*/
		//printf("Roditelj %d\n",id_reda);
		while(1)
		{
			semop(semid,&semaforP,1); //pokusava da pristupi stalku
			
			printf("Prisao stalku\n");
			
			if(stalak->naraspolaganju>0)
			{
				printf("Uzeo loptu\n");
				sleep(1); //uzima loptu
				
				//if(ind!=POZIV_ZA_POMOC)
					stalak->naraspolaganju-=1; //suta na kos ako nije primio poziv, kad izvrsi poziv ind=0
				//else
				sleep(3);//baca na kos
				semop(semid,&redarV,1); //poziva redara da pokupi loptu
				
				//pom je novo sutiranje, pogodio_promasio je prethodno
				//if((pom=rand()%2)==PROMASIO && pogodio_promasio==PROMASIO)
					//kill(pid,SIGINT); //salje detetu poziv za pomoc
				pom=rand()%2;
				if(pogodio_promasio==POGODIO && pom==PROMASIO)
				{
					pogodio_promasio=pom; //=1
					printf("Promasio sam %d\n",poruka.brojubacenih);
				}
				else if(pogodio_promasio==POGODIO && pom==POGODIO)
				{
					pogodio_promasio=pom;
					poruka.brojubacenih++;
					printf("Pogodio sam %d\n",poruka.brojubacenih);
					msgsnd(id_reda,&poruka,sizeof(poruka),0);
					
				}
				else if(pogodio_promasio==PROMASIO && pom==POGODIO)
				{
					pogodio_promasio=pom;
					poruka.brojubacenih++;
					printf("Pogodio sam %d\n",poruka.brojubacenih);
					msgsnd(id_reda,&poruka,sizeof(poruka),0);
				}
					
			}
			
			semop(semid,&semaforV,1); //zavrsio sa stalkom
			sleep(5);
		}
	}
	
	
	shmdt(stalak);
}
