#include <stdio.h>
#include <stdlib.h>
#include <sys/msg.h>
#include <sys/ipc.h>
#include <signal.h>
#include <unistd.h>

#define MESSAGE_TEXT_LIMIT 100
#define PROJ_PATH "./server"
#define PROJ_ID 'S'
#define MSG_TYP_REGISTER 'r'

int msqid;

struct msg {
	long type;
	pid_t pid;
};

struct chat {
	long type;
	int n;
	pid_t pid[20];
	char text[MESSAGE_TEXT_LIMIT];
};

void signal_handler(int signal)
{
	printf("Server: prihvacen SIGINT, brisem red za poruke.\n");
	msgctl(msqid, IPC_RMID, NULL);
	
}

int main(void)
{
	signal(SIGINT, signal_handler);
	int i, n;
	key_t key;
	struct chat c;
	struct msg m;
	
	key = ftok(PROJ_PATH, PROJ_ID);
	msqid = msgget(key, 0666 | IPC_CREAT);
	
	m.type = MSG_TYP_REGISTER;
	m.pid = getpid();
	
	printf("Saljem poruku sadrzine:\n\ttype = 'r';\n\tpid = %d;\n", m.pid);
	
	msgsnd(msqid, &m, sizeof(m), 0);
	
	printf("Cekam poruku sadrzine:\n\ttype = %d;\n\tn = (?);\n\ttext = \"REGISTER\"\n", getpid());
	
	msgrcv(msqid, &c, sizeof(c), (long)getpid(), 0);
	
	return EXIT_SUCCESS;
}
