#include <stdio.h>
#include <stdlib.h>
#include <sys/msg.h>
#include <sys/ipc.h>
#include <signal.h>
#include <unistd.h>
#include <string.h>

#define MESSAGE_TEXT_LIMIT 100
#define PROJ_PATH "./server"
#define PROJ_ID 'S'
#define MSG_TYP_REGISTER 'r'

int msqid;

struct msg {
	long type;
	pid_t pid;
};

struct chat {
	long type;
	int n;
	pid_t pid[20];
	char text[MESSAGE_TEXT_LIMIT];
};

void signal_handler(int signal)
{
	printf("Server: prihvacen SIGINT, brisem red za poruke.\n");
	msgctl(msqid, IPC_RMID, NULL);
	
}

int main(void)
{
	signal(SIGINT, signal_handler);
	int i, n;
	key_t key;
	struct chat c;
	struct msg m;
	
	printf("Unijeti broj klijenata za prijavu: ");
	scanf("%d", &n);
	
	key = ftok(PROJ_PATH, PROJ_ID);
	msqid = msgget(key, 0666 | IPC_CREAT);
	
	for(i = 0; i < n; i++) {
		printf("Cekam poruku sadrzine:\n\ttype = 'r';\n\tpid = (?);\n");
		
		msgrcv(msqid, &m, sizeof(m), MSG_TYP_REGISTER, 0);
		
		c.pid[i] = m.pid;
	}
	
	c.n = n;
	strcpy(c.text, "REGISTER");
	for(i = 0; i < n; i++) {
		c.type = c.pid[i];
		
		printf("Saljem poruku sadrzine:\n\ttype = %ld;\n\tn = %d;\n\ttext = \"%s\";\n", c.type, c.n, c.text);
		msgsnd(msqid, &m, sizeof(m), 0);
	}
	
	printf("Unijeti poruku za slanje:\n");
	scanf("%s", c.text);
	
	for(i = 0; (c.text[i] != '\0') && (c.text[i] != '\n'); i++);
	c.text[i] = '\0';
	
	c.n = n;
	c.type = c.pid[rand() % n];
	strcpy(c.text, "REGISTER");
	printf("Saljem poruku sadrzine:\n\ttype = %ld;\n\ttext = \"%s\"", c.type, c.text);
	
	return EXIT_SUCCESS;
}
