#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int idReda;

struct prijava
{
	long tip;
	int rbr;
	pid_t pid_klijenta;
};

struct obavestenjeP
{
	long tip;
	int brPrijavljenih;
};

struct poruka
{
	long tip;
	char tekst[15];
};

void handler(int sig)
{
	printf("UHVACEN SIGINT!\n");
	msgctl(idReda, IPC_RMID,NULL);
	exit(0);
}

int main()
{
	int N;
	int klijent, sledeci;
	key_t kljuc;
	char rec[15];
	
	signal(SIGINT, handler);
	
	struct prijava prijavaK;
	struct obavestenjeP obavestenje;
	struct poruka por;
	
	kljuc=ftok("./server.c",1);
	idReda=msgget(kljuc, IPC_CREAT|0666);
	
	prijavaK.tip=5;
	prijavaK.pid_klijenta=getpid(); 
	msgsnd(idReda, &prijavaK, sizeof(prijavaK),0);
	
	msgrcv(idReda, &prijavaK, sizeof(prijavaK), getpid(),0);
	
	klijent=prijavaK.rbr;
	printf("RBR %d\n", klijent);
	
	msgrcv(idReda, &obavestenje, sizeof(obavestenje), klijent, 0);
	
	N=obavestenje.brPrijavljenih;
	
	while(1)
	{
		printf("Cekam poruku tip %d\n", klijent);
		msgrcv(idReda, &por, sizeof(por), klijent, 0);
		printf("Primio poruku , tekst_poruke: %s \n",por.tekst);
		por.tekst[strlen(por.tekst)-1]='\0';
		sledeci=rand()%N+1;	
		while(sledeci==klijent)
		{
			sledeci=rand()%N+1;
		}
		
		printf("Unesite poruku : ");
		fgets(rec, sizeof(rec), stdin);
		
		por.tip=sledeci;
		strcpy(por.tekst, rec);
		por.tekst[strlen(por.tekst)-1]='\0';
		printf("Saljem poruku :tip %d, tekst_poruke %s\n",  sledeci , por.tekst); 
		msgsnd(idReda, &por, sizeof(por),0);
	}
	return 0;
}
