#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct moja_poruka {
	long tip;
	int pid;
	int id;
	int ukupno;
	char tekst[100];
};

int id_reda;

void handler (int sig) {
	printf("Brisanje reda za poruke\n");
	msgctl(id_reda, IPC_RMID, NULL);
	exit(1);
}

int main() {
	srand(time(NULL));
	key_t kljuc;
	int n, pom;
	struct moja_poruka poruka;
	
	signal(SIGINT, handler);
	
	kljuc = ftok("server.c", 'c');
	id_reda = msgget(kljuc, IPC_CREAT|0666);
	
	poruka.tip = 123;
	poruka.pid = getpid();
	msgsnd(id_reda, &poruka, sizeof(poruka), 0);
	printf("Prijavio sam se serveru\n");
	
	msgrcv(id_reda, &poruka, sizeof(poruka), getpid(), 0);
	n = poruka.ukupno + 1;
	
	pom = poruka.id;
	
	while(1) {
		printf("Cekam poruku: tip %d\n", pom);
		msgrcv(id_reda, &poruka, sizeof(poruka), pom, 0);
		printf("Primljena poruka: %s\n", poruka.tekst);
		
		poruka.tip = rand()%n;
		while (poruka.tip == poruka.id)
			poruka.tip = rand()%n;
		while (poruka.tip == 0)
			poruka.tip = rand()%n;
		
		poruka.id = pom;
		
		poruka.id = poruka.tip;
		printf("Unesite poruku: ");
		fgets(poruka.tekst, sizeof(poruka.tekst), stdin);
		printf("Saljem poruku: tip %ld, tekst_poruke %s\n", poruka.tip, poruka.tekst);
		msgsnd(id_reda, &poruka, sizeof(poruka), 0);
	}
	
	return 0;
}

