#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union unija {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

typedef struct igrac {
	int id;
} IGRAC;

int kos[4];
int semid;
int *broj_igraca;
void handler (int sig) {
	int i;
	for (i = 1; i <= 4; i++) 
		printf("U %d. kos je ubaceno %d\n", i, kos[i]);
	
	printf("Brisanje semafora\n");
	for (i = 0; i <= (*broj_igraca); i++)
		semctl(semid, i, IPC_RMID);
	exit(1);
}

int main() {
	key_t kljuc;
	int shmid1, shmid2, shmid3, shmid4, shmid5;
	int *lopte, *koriscene, *red, *ind;
	int kos[4];
	int koji_kos;
	//int koji_igrac;
	int i;
	int ubacio;
	union unija operacija;
	struct sembuf povecaj, smanji;
	IGRAC igraci;
	
	signal(SIGINT, handler);
	
	kljuc = ftok("redar.c", 'b');
	
	shmid1 = shmget(kljuc, sizeof(int), IPC_CREAT|0666);
	shmid2 = shmget(kljuc, sizeof(int), IPC_CREAT|0666);
	shmid3 = shmget(kljuc, sizeof(int), IPC_CREAT|0666);
	shmid4 = shmget(kljuc, sizeof(int), IPC_CREAT|0666);
	shmid5 = shmget(kljuc, sizeof(int), IPC_CREAT|0666);
	
	lopte = (int*)shmat(shmid1, NULL, 0);
	koriscene = (int*)shmat(shmid2, NULL, 0);
	broj_igraca = (int*)shmat(shmid3, NULL, 0);
	red = (int*)shmat(shmid4, NULL, 0);
	ind = (int*)shmat(shmid5, NULL, 0);
	
	semid = semget(kljuc, 5, IPC_CREAT|IPC_EXCL|0666);
	
	if (semid != -1) {
		printf("Pravim semafor\n");
		operacija.val = 1;
		semctl(semid, 0, SETVAL, operacija);
		for (i = 1; i <= *broj_igraca; i++) {
			operacija.val = 0;
			semctl(semid, i, SETVAL, operacija);
		}
	}
	
	else if (errno == EEXIST) {
		printf("Semafor vec postoji\n");
		semid = semget(kljuc, 5, 0);
	}
	
	else {
		printf("Greska\n");
		exit(1);
	}
	
	//koji_igrac = rand()%(*broj_igraca);
	//igraci[koji_igrac].pid = getpid();
	
	*ind = 0;
	while(1) {
		igraci.id = *red;
		smanji.sem_num = igraci.id;
		smanji.sem_op = -1;
		smanji.sem_flg = 0;
		
		semop(semid, &smanji, 1);
		printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", smanji.sem_num, semid, smanji.sem_op);
		
		while (*ind == 1) //0 stalak je slobodan
			printf("Stalak nije slobodan");
		
		if (*lopte > 0) {
			*ind = 1;
			printf("Uzimam loptu sa stalka\n");
			sleep(1);
			*koriscene += 1;
			*lopte -= 1;
			*ind = 0;
		}
		
		else {
			povecaj.sem_num = 0;
			povecaj.sem_op = 1;
			povecaj.sem_flg = 0;
			printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", povecaj.sem_num, semid, povecaj.sem_op);
			semop(semid, &povecaj, 1);
		}
		
		*red = rand()%(*broj_igraca + 1);
		
		igraci.id = *red;
		povecaj.sem_num = igraci.id;
		povecaj.sem_op = 1;
		povecaj.sem_flg = 0;
		
		printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", povecaj.sem_num, semid, povecaj.sem_op);
		semop(semid, &povecaj, 1);
		
		koji_kos = rand()%4;
		ubacio = rand()%2; //0-nije ubacio, 1-jeste ubacio
		if (ubacio == 1)
			kos[koji_kos] += 1;
		
	}
	
	shmdt(lopte);
	shmdt(koriscene);
	shmdt(broj_igraca);
	shmdt(red);
	return 0;
}

