#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union unija {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int kos[4];
int semid;
int *broj_igraca;
void handler (int sig) {
	int i;
	for (i = 1; i <= 4; i++) 
		printf("U %d. kos je ubaceno %d\n", i, kos[i]);
	
	printf("Brisanje semafora\n");
	for (i = 0; i <= (*broj_igraca); i++)
		semctl(semid, i, IPC_RMID);

	exit(1);
}

int main() {
	srand(time(NULL));
	key_t kljuc;
	int shmid1, shmid2, shmid3, shmid4, shmid5;
	int *lopte, *koriscene, *red, *ind;
	union unija operacija;
	struct sembuf povecaj, smanji;
	int i;
	
	signal(SIGINT, handler);
	
	kljuc = ftok("redar.c", 'b');
	
	shmid1 = shmget(kljuc, sizeof(int), IPC_CREAT|0666);
	shmid2 = shmget(kljuc, sizeof(int), IPC_CREAT|0666);
	shmid3 = shmget(kljuc, sizeof(int), IPC_CREAT|0666);
	shmid4 = shmget(kljuc, sizeof(int), IPC_CREAT|0666);
	shmid5 = shmget(kljuc, sizeof(int), IPC_CREAT|0666);
	
	lopte = (int*)shmat(shmid1, NULL, 0);
	koriscene = (int*)shmat(shmid2, NULL, 0);
	broj_igraca = (int*)shmat(shmid3, NULL, 0);
	red = (int*)shmat(shmid4, NULL, 0);
	ind = (int*)shmat(shmid5, NULL, 0);
	
	semid = semget(kljuc, 5, IPC_CREAT|IPC_EXCL|0666);
	
	if (semid != -1) {
		printf("Pravim semafor\n");
		operacija.val = 1;
		semctl(semid, 0, SETVAL, operacija);
		for (i = 1; i <= (*broj_igraca); i++) {
			operacija.val = 0;
			semctl(semid, i, SETVAL, operacija);
		}
	}
	
	else if (errno == EEXIST) {
		printf("Semafor vec postoji\n");
		semid = semget(kljuc, 5, 0);
	}
	
	else {
		printf("Greska\n");
		exit(1);
	}
	
	/* *broj_igraca = rand()%13;
	while(*broj_igraca == 0)
		*broj_igraca = rand()%13;*/

	*broj_igraca = 3;
	printf("Broj igraca je %d\n", *broj_igraca);
	
	*lopte = rand()%11;
	while(*lopte == 0)
		*lopte = rand()%11;
		
	printf("Broj lopti koje se mogu koristiti %d\n", *lopte);
	
	smanji.sem_num = 0;
	smanji.sem_op = -1;
	smanji.sem_flg = 0;
	
	int in = 0;
	while(1) {
		semop(semid, &smanji, 1);
		printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", smanji.sem_num, semid, smanji.sem_op);

		*red = rand()%(*broj_igraca + 1);
		while(*red == 0)
			*red = rand()%(*broj_igraca + 1);
		
		printf("RED je %d\n", *red);
		povecaj.sem_num = *red;
		povecaj.sem_op = 1;
		povecaj.sem_flg = 0;
		
		if (in == 0) { //na pocetku sve lopte su na stalku
			printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", povecaj.sem_num, semid, povecaj.sem_op);
			semop(semid, &povecaj, 1);
		}
		
		else {
			*ind = 1;
			printf("REDAR: Vracam loptu na stalak\n");
			sleep(2);
			*lopte += *koriscene;
			*ind = 0;
			printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", povecaj.sem_num, semid, povecaj.sem_op);
			semop(semid, &povecaj, 1);
		}
	}
	
	shmdt(lopte);
	shmdt(koriscene);
	shmdt(broj_igraca);
	shmdt(red);
	shmdt(ind);
	return 0;
}

