#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

//Prvo se pokrece redar.c zbog broja lopti, pa posle njega igrac.c

union semunija{
	int val;
	struct semid_ds *buff;
	ushort *array;
};

int semid;

typedef struct Kos_s{
	int stalak, kos1, kos2, kos3, kos4;
}Kos;

Kos *k;


void IzbrisiSemafore(int sig)
{
	printf("\n\nUhvacen signal SIGINT.\n");

	printf("Kos1: %d\n", k->kos1);
	printf("Kos2: %d\n", k->kos2);
	printf("Kos3: %d\n", k->kos3);
	printf("Kos4: %d\n", k->kos4);
	
	printf("Brisem semafore...\n");
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);

	printf("Zavrsavam...\n");
	exit(0);
}

void main()
{
	int shmid, br, ind;
	key_t kljuc;
	
	
	union semunija operacije_nad_sem;
	struct sembuf op_p, op_v, op_v2;

	signal(SIGINT, IzbrisiSemafore);
	srand(time(0));

	kljuc = ftok("igrac.c", 'A');
	shmid = shmget(kljuc, sizeof(Kos), 0666|IPC_CREAT);
	semid = semget(kljuc, 2, 0666|IPC_CREAT|IPC_EXCL);
	k = (Kos*)shmat(shmid, (void *)0, 0);
	
	if(semid != -1)
	{
		printf("Semafori se kreiraju.\n");
		
		operacije_nad_sem.val = 1;
		semctl(semid, 0, SETVAL, operacije_nad_sem);

		operacije_nad_sem.val = 0;
		semctl(semid, 1, SETVAL, operacije_nad_sem);

	}
	else if(errno == EEXIST)
	{
		printf("Povezujem se.\n");
		semid = semget(kljuc, 2, 0);
	}
	else
	{
		printf("Greska.\n");
		exit(0);
	}

	op_p.sem_num = 0;
	op_p.sem_op = -1;
	op_p.sem_flg = 0;
	
	op_v.sem_num = 0;
	op_v.sem_op = 1;
	op_v.sem_flg = 0;

	op_v2.sem_num = 1;
	op_v2.sem_op = 1;
	op_v2.sem_flg = 0;

	while(1)
	{
		printf("\nSmanjujem semafor '0', %d skupa za vrednost 1.\n", semid);
		sleep(3);
		semop(semid, &op_p, 1);

		if(k->stalak > 0)
		{
			printf("Uzimam loptu.\n");
			--k->stalak;
			sleep(1);
			ind = 1;
		}
		else
		{
			printf("Nema lopti.\n");
			ind = 0;
		}

		printf("Povecavam semafor '0', %d skupa za vrednost 1.\n", semid);
		sleep(3);
		semop(semid, &op_v, 1); //da moze drugi igrac da uzme loptu;


		printf("Stalak je slobodan.\n");
		printf("Povecavam semafor '1', %d skupa za vrednost 1.\n", semid);
		sleep(3);
		semop(semid, &op_v2, 1);

		br = rand() % 4;

		if(br == 0 && ind == 1)		//kos1
		{
			printf("Bacanje...\n");
			br = rand() % 2;
			if(br == 1)
			{
				++k->kos1;
				printf("Pogodak.\n");
			}
			sleep(3);	
		}
		else if(br == 1 && ind == 1)	//kos2
		{
			printf("Bacanje...\n");
			br = rand() % 2;
			if(br == 1)
			{
				++k->kos2;
				printf("Pogodak.\n");
			}
			sleep(3);
		}
		else if(br == 2 && ind == 1)	//kos3
		{
			printf("Bacanje...\n");
			br = rand() % 2;
			if(br == 1)
			{
				++k->kos3;
				printf("Pogodak.\n");
			}
			sleep(3);
		}
		else if(br == 3 && ind == 1)	//kos4
		{
			printf("Bacanje...\n");
			br = rand() % 2;
			if(br == 1)
			{
				++k->kos4;
				printf("Pogodak.\n");
			}
			sleep(3);
		}
	}
}
