#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

//Prvo se pokrece redar.c zbog broja lopti, pa posle njega igrac.c

union semunija{
	int val;
	struct semid_ds *buff;
	ushort *array;
};

typedef struct Kos_s{
	int stalak, kos1, kos2, kos3, kos4;
}Kos;

int semid;

void IzbrisiSemafore(int sig)
{
	printf("\n\nUhvacen signal SIGINT.\n");
	
	printf("Brisem semafore...\n");
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);

	printf("Zavrsavam...\n");
	exit(0);
}

void main()
{
	int shmid, n;
	key_t kljuc;
	Kos *k;
	
	union semunija operacije_nad_sem;
	struct sembuf op_p, op_p2, op_v;

	signal(SIGINT, IzbrisiSemafore);

	kljuc = ftok("igrac.c", 'A');
	shmid = shmget(kljuc, sizeof(Kos), 0666|IPC_CREAT);
	semid = semget(kljuc, 2, 0666|IPC_CREAT|IPC_EXCL);
	k = (Kos*)shmat(shmid, (void *)0, 0);

	printf("Uneti broj lopti: ");	
	scanf("%d", &k->stalak);

	n = k->stalak;
	k->kos1 = k->kos2 = k->kos3 = k->kos4 = 0;

	if(semid != -1)
	{
		printf("Semafori se kreiraju.\n");
		
		operacije_nad_sem.val = 1;
		semctl(semid, 0, SETVAL, operacije_nad_sem);

		operacije_nad_sem.val = 0;
		semctl(semid, 1, SETVAL, operacije_nad_sem);
	}
	else if(errno == EEXIST)
	{
		printf("Povezujem se.\n");
		semid = semget(kljuc, 2, 0);
	}
	else
	{
		printf("Greska.\n");
		exit(0);
	}
	
	op_p.sem_num = 1;
	op_p.sem_op = -1;
	op_p.sem_flg = 0;

	op_p2.sem_num = 0;
	op_p2.sem_op = -1;
	op_p2.sem_flg = 0;
	
	op_v.sem_num = 0;
	op_v.sem_op = 1;
	op_v.sem_flg = 0;

	while(1)
	{
		printf("\nSmanjujem semafor '1', %d skupa za vrednost 1.\n", semid);
		sleep(3);
		semop(semid, &op_p, 1);
		printf("Smanjujem semafor '0', %d skupa za vrednost 1.\n", semid); //ne sme igrac da bude ispred stalka kad vraca loptu;
		sleep(3);
		semop(semid, &op_p2, 1);		

		if(k->stalak < n)
		{
			printf("Vracam loptu.\n");
			++k->stalak;
			sleep(2);
		}
		printf("Stalak je slobodan.\n");
		
		printf("Povecavam semafor '0', %d skupa za vrednost 1.\n", semid);
		//stalak je slobodan, igrac moze loptu da uzme;
		sleep(3);
		semop(semid, &op_v, 1);
	}
}
