#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1024

int idSem, idMem, idReda, *brLopti, rbKosa;
pid_t dete;

struct poruka{
	long tip;
	int kos; //na kom kosu je potrebna pomoc
};

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

void sighandler(int sig){
	printf("uhvacen signal\n");
	msgctl(idReda, IPC_RMID, NULL);	
	semctl(idSem, 0, IPC_RMID);
	semctl(idSem, 1, IPC_RMID);
	semctl(idSem, 2, IPC_RMID);
	semctl(idSem, 3, IPC_RMID);
	semctl(idSem, 4, IPC_RMID);
	shmctl(idMem, IPC_RMID, NULL);
	shmdt(brLopti);
	kill(dete, SIGKILL);
	exit(0);
}

void help(int sig){
	printf("trazim pomoc....\n");
	int i;
	struct poruka p;
	p.kos = rbKosa;
	i = rand()%4 + 1;
	while(i == rbKosa)
		i = rand()%4 + 1;
	printf("saljem pomoc %d igracu\n", i);
	p.tip = i;
	msgsnd(idReda, &p, sizeof(p), 0);
}



int main(){
	srand(time(0));
	int rbKosa, pogodak, pomoc = 0, brKoseva = 0, ind, lopta = 0;
	scanf("%d", &rbKosa);
	key_t kljuc;
	union semun operacija;
	struct sembuf povecaj, smanji, stalakP, stalakS;
	struct poruka p;
	
	kljuc = ftok("igrac1.c", 42);
	idReda = msgget(kljuc, 0666|IPC_CREAT);
	idMem = shmget(kljuc, SHM_SIZE * sizeof(int), 0666|IPC_CREAT|IPC_EXCL);
	
		brLopti = shmat(idMem, NULL, 0);
		brLopti[0] = 5;
		brLopti[rbKosa] = 0;

	idSem = semget(kljuc, 5, 0666|IPC_CREAT|IPC_EXCL);
	if(idSem != -1)
	{
		operacija.val = 1;
		semctl(idSem, 0, SETVAL, operacija); //stalak
		semctl(idSem, 1, SETVAL, operacija); //kos1
		semctl(idSem, 2, SETVAL, operacija); //kos2
		semctl(idSem, 3, SETVAL, operacija); //kos3
		semctl(idSem, 4, SETVAL, operacija); //kos4
	}
	else if (errno == EEXIST)
	{
		idSem = semget(kljuc, 5, 0);
	}
	else
	{
		printf("neka druga greska\n");
		exit(0);
	}

	stalakP.sem_num = 0;
	stalakP.sem_op = 1;
	stalakP.sem_flg = 0;
	
	stalakS.sem_num = 0;
	stalakS.sem_op = -1;
	stalakS.sem_flg = 0;	
	
	povecaj.sem_num = rbKosa;
	povecaj.sem_op = 1;
	povecaj.sem_flg = 0;
	
	smanji.sem_num = rbKosa;
	smanji.sem_op = -1;
	smanji.sem_flg = 0;
	printf("sadrzaj deljene memorije: [0]%d [1]%d [2]%d [3]%d [4]%d \n",
		brLopti[0], brLopti[1], brLopti[2], brLopti[3], brLopti[4]);
	dete = fork();
	while(1){
		if( dete == 0) //statistika(dete)
		{
			sleep(5);
			printf("br Koseva je: %d\n", brLopti[rbKosa]);
			signal(SIGINT, help);
		}
		else	//roditelj
		{
			signal(SIGINT, sighandler);
			//prilazi stalku 
			semop(idSem, &stalakS, 1);
			if( brLopti[0] > 0)
			{
				brLopti[0]--;
				lopta = 1;
				printf("uzimam loptu sa stalka..ostalo: [%d]\n", brLopti[0]);
				sleep(1);
			}
			semop(idSem, &stalakP, 1);
			if(lopta == 1)
			{
				ind = msgrcv(idReda, &p, sizeof(p), rbKosa, IPC_NOWAIT);
				if(ind == -1) //nemam zahtev za pomoc
				{
					semop(idSem, &smanji, 1);
					pogodak = rand()%2;
					printf("sut na kos: %d \n", pogodak);
					if(pogodak == 0)
						pomoc++;
					else
					{
						brLopti[rbKosa]++;
						pomoc = 0;
					}
					if(pomoc == 2)
					{
						kill(dete, SIGINT);
						printf("poslati signal detetu\n");
					}
					sleep(3);
					semop(idSem, &povecaj, 1);
				}
				else //pomazem
				{
					printf("pomazem\n");
					int pom;
					pom = p.kos;
					smanji.sem_num = pom;
					povecaj.sem_num = pom;
					
					semop(idSem, &smanji, 1);
					pogodak = rand()%2;
					printf("sut na %d kos: %d \n", pom, pogodak);
					if(pogodak == 1)
						brLopti[pom]++;
					povecaj.sem_num = rbKosa;
					smanji.sem_num = rbKosa;
				}
			}
			else
			{
				printf("nemam loptu.. cekam\n");
				sleep(4);
			}
			lopta = 0;				
		}
	
	}
	return 0;
}
