#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;/* used for SETVAL only */
	struct semid_ds *buf; /* used for IPC_STAT and IPC_SET */
	ushort *array;/* used for GETALL and SETALL */
};

int semid, shmid1, shmid2;
int *lopte;
int *kos;

#define N 5 

void hend(int sig)
{
	printf("\nPRIMIO SIGNAL\n");
	printf("\nOSTALO JE %d LOPTI\n", (*lopte));
	printf("KOS 0: %d\n", kos[0]);
	printf("KOS 1: %d\n", kos[1]);
	printf("KOS 2: %d\n", kos[2]);
	printf("KOS 3: %d\n", kos[3]);
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	semctl(semid, 4, IPC_RMID);
	semctl(semid, 5, IPC_RMID);
	
	
	shmdt(lopte);
	shmdt(kos);
	
	shmctl(shmid1, IPC_RMID, NULL);
	shmctl(shmid1, IPC_RMID, NULL);
	exit(0);
}

int main()
{
	srand(time(NULL));
	key_t kljuc;
	union semun opr;
	struct sembuf pov, sma, povl, smal, povr, smar;
	int kojikos, poen;
	/*
	 * semafori
	 * 0-3=kosevi
	 * 4=lopte
	 * 5=redar
	 */
	
	//lopte
	kljuc=ftok("./igraci.c", 3);
	shmid1=shmget(kljuc, sizeof(int), IPC_CREAT|0666);
	lopte=shmat(shmid1, NULL, 0);
	
	//kosevi
	kljuc=ftok("./igraci.c", 4);
	shmid2=shmget(kljuc, 4*sizeof(int), IPC_CREAT|0666);
	kos=shmat(shmid2, NULL, 0);
	
	//semafori
	kljuc=ftok("./igraci.c", 5);
	semid=semget(kljuc, 6, IPC_CREAT|0666|IPC_EXCL);
	
	signal(SIGINT, hend);
	
	if(semid != -1)
	{
		printf("Kreira se\n");
		opr.val=1;
		semctl(semid, 0, SETVAL, opr);
		semctl(semid, 1, SETVAL, opr);
		semctl(semid, 2, SETVAL, opr);
		semctl(semid, 3, SETVAL, opr);
		semctl(semid, 4, SETVAL, opr);
		semctl(semid, 5, SETVAL, opr);
		
		kos[0]=0;
		kos[1]=0;
		kos[2]=0;
		kos[3]=0;
		
		*lopte=N;
		
	}
	else if( errno == EEXIST)
	{
		printf("Kacim se\n");
		semid=semget(kljuc, 6, 0);
	}
	else
	{
		printf("Greska\n\n");
		exit(0);
	}
	
	povl.sem_num = 4;
	povl.sem_op = 1;
	povl.sem_flg = 0;
	smal.sem_num = 4;
	smal.sem_op = -1;
	smal.sem_flg = 0;
	
	povr.sem_num = 5;
	povr.sem_op = 1;
	povr.sem_flg = 0;
	smar.sem_num = 5;
	smar.sem_op = -1;
	smar.sem_flg = 0;
	
	
	
	int ind;
	
	while(1)
	{
		if((*lopte)>0)
		{
			printf("Smanjujem semafor lopti iz skupa %d za vrednost 1\n", semid);
			sleep(3);
			ind=semop(semid, &smal, 1);
			
			*lopte=(*lopte)-1;
			sleep(1); //UZIMA
			
			printf("Broj lopti nakon suta: %d\n", (*lopte));
			
			printf("Povecavam semafor lopti iz skupa %d za vrednost 1\n", semid);
			sleep(3);
			ind=semop(semid, &povl, 1);
			
			kojikos=rand() % 4;
			printf("Gadjam kos %d\n", kojikos);
			
			
			poen=rand() % 2;
			
			pov.sem_num = kojikos;
			pov.sem_op = 1;
			pov.sem_flg = 0;
			sma.sem_num = kojikos;
			sma.sem_op = -1;
			sma.sem_flg = 0;
			
			printf("Smanjujem semafor kosa %d iz skupa %d za vrednost 1\n", kojikos, semid);
			sleep(3);
			ind=semop(semid, &sma, 1);
			
			sleep(3); //GADJA
			
			if(poen)
			{
				printf("Pogodio je u kos %d\n", kojikos);
				kos[kojikos]+=1;
			}
			else
			{
				printf("Omasio je kos %d\n", kojikos);
			}
			
			printf("KOS 0: %d\n", kos[0]);
			printf("KOS 1: %d\n", kos[1]);
			printf("KOS 2: %d\n", kos[2]);
			printf("KOS 3: %d\n", kos[3]);
			
			printf("Povecavam semafor kos iz skupa %d za vrednost 1\n", semid);
			sleep(3);
			ind=semop(semid, &pov, 1);
		}
		
		printf("Smanjujem semafor redar iz skupa %d za vrednost 1\n", semid);
		sleep(3);
		ind=semop(semid, &smar, 1);
		
		printf("Smanjujem semafor lopti iz skupa %d za vrednost 1\n", semid);
		sleep(3);
		ind=semop(semid, &smal, 1);
		
		sleep(2);//VRACA
		
		*lopte=(*lopte)+1;
		
		printf("Broj lopti nakon redara: %d\n", (*lopte));
		
		printf("Povecavam semafor lopti iz skupa %d za vrednost 1\n", semid);
		sleep(3);
		ind=semop(semid, &povl, 1);
		
		printf("Povecavam semafor redar iz skupa %d za vrednost 1\n", semid);
		sleep(3);
		ind=semop(semid, &povr, 1);
			
}
	
	
	

}
