#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>

int sem_id;

union unija
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

//3 semafora

void signal_handler(int sig)
{
	semctl(sem_id, 0, IPC_RMID);
	semctl(sem_id, 1, IPC_RMID);
	semctl(sem_id, 2, IPC_RMID);
	
	kill(getpid(), SIGKILL);
}

int main()
{
	for(int j = 1; j <= 64; j++)
		signal(j, signal_handler);
	
	int br = 0;
	int i = 1;
	
	union unija u1, u2, u3;
	struct sembuf P, V;
	key_t key;
	
	u1.val = 2;//pocetna vrednost prvog semafora
	u2.val = 0;//pocetna vrednost drugog semafora
	u3.val = 0;//pocetna vrednost treceg semafora
	
	key = ftok("prvi.c", 'R');
	
	if(key == -1)
	{
		perror("Nije moguce generisati kljuc\n");
		exit(0);
	}
	
	sem_id = semget(key, 3, 0644 | IPC_CREAT);
	if(sem_id != -1)//proveri za ovo
	{
		semctl(sem_id, 0, SETVAL, u1);
		semctl(sem_id, 1, SETVAL, u2);
		semctl(sem_id, 2, SETVAL, u3);
	}
	else if(errno == EEXIST)
	{
		semctl(sem_id, 0, SETVAL, u1);
		semctl(sem_id, 1, SETVAL, u2);
		semctl(sem_id, 2, SETVAL, u3);
	}
	else
	{
		perror("Greska pri pravljenju semafora\n");
		exit(0);
	}
	
	P.sem_num = 0;
	P.sem_op = -3;//vidi koliko
	P.sem_flg = 0;
	
	P.sem_num = 1;
	P.sem_op = -2;
	P.sem_flg = 0;
	
	P.sem_num = 2;
	P.sem_op = -1;
	P.sem_flg = 0;
	
	V.sem_num = 0;
	V.sem_op = 1;
	V.sem_flg = 0;
	
	V.sem_num = 1;
	V.sem_op = 2;
	V.sem_flg = 0;
	
	V.sem_num = 2;
	V.sem_op = 2;
	V.sem_flg = 0;
	
	while(1)
	{
		printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", 0, sem_id, -3);
		printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", 1, sem_id, -2);
		printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", 2, sem_id, -1);
		sleep(3);
		semop(sem_id, &P, 1);
		
		printf("Broj ispisa u prvom procesu: %d\n", br);
		
		while(!(i % 3 == 2))
			i++;
			
		printf("%d\n", i);
		
		i++;
		
		br++;
		
		printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", 0, sem_id, 1);
		printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", 1, sem_id, 2);
		printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", 2, sem_id, 3);
		sleep(3);
		semop(sem_id, &V, 1);
	}
	
	return 0;
}
