#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <time.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>

#define USLA 1
#define NIJE_USLA 0

union semun{
    int val;
    struct semid_ds *buf;
    ushort *array;
};

int semid;
int *kos1, *kos2, *kos3, *kos4, *stalak;
int shmid1, shmid2, shmid3, shmid4, shmid5;


void SignalHandler(int sig){
    printf("Uhvatio sam SIGINT.\n");
    printf("KOS1: %d\n", *kos1);
    printf("KOS2: %d\n", *kos2);
    printf("KOS3: %d\n", *kos3);
    printf("KOS4: %d\n", *kos4);

    semctl(semid, 0, IPC_RMID);
    semctl(semid, 1, IPC_RMID);
    shmdt(kos1);
    shmdt(kos2);
    shmdt(kos3);
    shmdt(kos4);
    shmdt(stalak);
    shmctl(shmid1, IPC_RMID, NULL);
    shmctl(shmid2, IPC_RMID, NULL);
    shmctl(shmid3, IPC_RMID, NULL);
    shmctl(shmid4, IPC_RMID, NULL);
    shmctl(shmid5, IPC_RMID, NULL);
    exit(0);
}

int main(){
    key_t key;
    int x;
    int ind;

    union semun arg;
    struct sembuf p1, p2, v1, v2;

    signal(SIGINT, SignalHandler);

    key = ftok("./igrac.c", 'a');
    shmid1 = shmget(key, sizeof(int), 0666|IPC_CREAT);
    kos1 = shmat(shmid1, NULL, 0);

    key = ftok("./igrac.c", 'b');
    shmid2 = shmget(key, sizeof(int), 0666|IPC_CREAT);
    kos2 = shmat(shmid2, NULL, 0);

    key = ftok("./igrac.c", 'c');
    shmid3 = shmget(key, sizeof(int), 0666|IPC_CREAT);
    kos3 = shmat(shmid3, NULL, 0);

    key = ftok("./igrac.c", 'd');
    shmid4 = shmget(key, sizeof(int), 0666|IPC_CREAT);
    kos4 = shmat(shmid4, NULL, 0);

    key = ftok("./igrac.c", 'e');
    shmid5 = shmget(key, sizeof(int), 0666|IPC_CREAT);
    stalak = shmat(shmid5, NULL, 0);

    key = ftok("./igrac.h", 1);
    semid = semget(key,3, 0666|IPC_CREAT|IPC_EXCL);

    if(semid != -1){
        printf("Ja sam napravio semafor, id %d.\n", semid);
        printf("Unesite broj lopti: ");
        scanf("%d", &x);
        *stalak = x;

        arg.val = x;
        semctl(semid, 0, SETVAL, arg);
        arg.val = 1;
        semctl(semid, 1, SETVAL, arg);
        arg.val = 0;
        semctl(semid, 2, SETVAL, arg);

        *kos1 = 0;
        *kos2 = 0;
        *kos3 = 0;
        *kos4 = 0;
    }
    else if(errno == EEXIST){
        semid = semget(key, 3, 0);
        printf("Semafor vec postoji, ja se samo povezujem, id %d.\n", semid);
    }
    else{
        printf("Neka druga greska!\n");
        exit(0);
    }

    //smanjuje broj lopti na stalku
    p1.sem_num = 0;
    p1.sem_op = -1;
    p1.sem_flg = 0;

    //zauzima stalak
    p2.sem_num = 1;
    p2.sem_op = -1;
    p2.sem_flg = 0;

    //baca loptu i pokrece redara
    v1.sem_num = 2;
    v1.sem_op = 1;
    v1.sem_flg = 0;

    //oslobadja stalak
    v2.sem_num = 1;
    v2.sem_op = 1;
    v2.sem_flg = 0;

    int kosRandom;
    int usla;
    srand(time(0));
    while(1){
        printf("Smanjujem semafor %d iz skupa %d za vrednost %d.\n", p1.sem_num, semid, p1.sem_op);
        sleep(3);
        ind = semop(semid, &p1, 1);
        if(ind == -1)
            break;

        printf("Smanjujem semafor %d iz skupa %d za vrednost %d.\n", p2.sem_num, semid, p2.sem_op);
        sleep(3);
        printf("Prilazim stalku, ako smem.\n");
        ind = semop(semid, &p2, 1);
        if(ind == -1)
            break;
        
        printf("Uzimam loptu.\n");
        sleep(1);

        printf("Povecam semafor %d iz skupa %d za vrednost %d.\n", v2.sem_num, semid, v2.sem_op);
        printf("Oslobadjam stalak.\n");
        sleep(3);
        ind = semop(semid, &v2, 1);
        if(ind == -1)
            break;

        printf("Povecam semafor %d iz skupa %d za vrednost %d.\n", v1.sem_num, semid, v1.sem_op);
        sleep(3);
        ind = semop(semid, &v1, 1);
        if(ind == -1)
            break;

        printf("BACAM LOPTU.\n");
        kosRandom = rand() % 4 + 1;
        usla = rand() % 2 + 1;

        if(usla == USLA){
            printf("Lopta usla u kos %d.\n", kosRandom);

            if(kosRandom == 1)
                *kos1 += 1;
            else if(kosRandom == 2)
                *kos2 += 1;
            else if(kosRandom == 3)
                *kos3 += 1;
            else if(kosRandom == 4)
                *kos4 += 1;
        }
        else
            printf("Promasaj.\n");
        sleep(3);
    }


    return 0;
}