#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHMSIZE 24


union semun{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int shmid;
int *stalak;
int *kos[4];

void signal_handler(int sig){
	int i;
	for (i=0; i<4; i++)	printf("U kos br %d: %d", i, *kos[i]);
	
	shmctl(shmid, IPC_RMID, NULL);
	exit(1);
}


int main(){
	
	int i, brKosa;
	
	srand(time(NULL));
	key_t key = ftok("./kosarka.c", 1);
	
	shmid = shmget(key, SHMSIZE, 0666|IPC_CREAT);
	printf("shmid: %d\n", shmid);
	
	stalak = shmat(shmid, NULL, 0); //br lopti na stalku
	for (i=0; i<4; i++) kos[i] = shmat(shmid, NULL, 0);
	
	*stalak = -1;
	for (i=0; i<4; i++){
		*kos[i] = 0;
	}
	
	int n;
	
	printf("Ucitaj br lopti: ");
	scanf("%d", &n);
	*stalak = n;
	
	int semid = semget(key, 6, 0666|IPC_CREAT|IPC_EXCL);
	
	union semun arg;
	
	if (semid != -1){ //ja kreiram i inicijalizujem
		printf("ja kreiram i inicijalizujem\n");
		arg.val = n;
		semctl(semid, 0, SETVAL, arg); //da li ima lopti
		arg.val = 1;
		for (i=1; i<=4; i++) semctl(semid, i, SETVAL, arg); //da li je kos slobodan
		semctl(semid, 5, SETVAL, arg); //da li je zauzet stalak
	}
	else if (errno == EEXIST){ //neko je vec kreirao, ja se samo povezujem
		printf("neko je vec kreirao, ja se samo povezujem\n");
		semid = semget(key, 6, 0);
	}
	else printf("\n\n\n\nneka druga greska\n");
	
	
	
	
	
	
	
	struct sembuf uzmiLoptu;
	uzmiLoptu.sem_num = 0;
	uzmiLoptu.sem_op = -1;
	uzmiLoptu.sem_flg = 0;
	
	struct sembuf zauzmiStalak;
	zauzmiStalak.sem_num = 5;
	zauzmiStalak.sem_op = -1;
	zauzmiStalak.sem_flg = 0;
	
	struct sembuf oslobodiStalak;
	oslobodiStalak.sem_num = 5;
	oslobodiStalak.sem_op = 1;
	oslobodiStalak.sem_flg = 0;
	
	
	struct sembuf zauzmiKos[4];
	for (i=1; i<=4; i++){
		zauzmiKos[i].sem_num = i;
		zauzmiKos[i].sem_op = -1;
		zauzmiKos[i].sem_flg = 0;
	}
	
	struct sembuf oslobodiKos[4];
	for (i=1; i<=4; i++){
		oslobodiKos[i].sem_num = i;
		oslobodiKos[i].sem_op = 1;
		oslobodiKos[i].sem_flg = 0;
	}
	
	while (1){
		
		
		//////
		//printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", zauzmiStalak.sem_num, semid, zauzmiStalak.sem_op);
		//printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", zauzmiStalak.sem_num, semid, zauzmiStalak.sem_op);
		/////
		
		
		printf("Smanjujem semafor %d iz skupa %d za vrednost %d\nZauzimam stalak\n", zauzmiStalak.sem_num, semid, zauzmiStalak.sem_op);
		semop(semid, &zauzmiStalak, 1); //cekam da se stalak oslobodi
		printf("Smanjujem semafor %d iz skupa %d za vrednost %d\nUzimam loptu sa stalka\n", uzmiLoptu.sem_num, semid, uzmiLoptu.sem_op);
		semop(semid, &uzmiLoptu, 1);
		*stalak -= 1;
		sleep(1);
		printf("Povecavam semafor %d iz skupa %d za vrednost %d\nOslobadjam stalak\n", oslobodiStalak.sem_num, semid, oslobodiStalak.sem_op);
		semop(semid, &oslobodiStalak, 1);
		
		
		brKosa = rand() % 4;
		
		printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", zauzmiKos[brKosa].sem_num, semid, zauzmiKos[brKosa].sem_op);
		semop(semid, &zauzmiKos[brKosa], 1);
		printf("Sutiram na kos %d\n", brKosa);
		sleep(3);
		printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", oslobodiKos[brKosa].sem_num, semid, oslobodiKos[brKosa].sem_op);
		semop(semid, &oslobodiKos[brKosa], 1);
		
		*kos[brKosa] += rand() % 2;
		
	}
	
	
	
	
	
	
	return 0;
}
