#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <string.h>
#include <time.h>

pid_t pid1, pid2, pid3;
int rbr;
int naRedu = 1;

struct poruka
{
	long tip;
	char tekst[100];
};

void signal_handler(int sig)
{
	naRedu = rbr;
}

int main()
{
	int id_reda;
	key_t key;
	signal(SIGCHLD, signal_handler);
	
	//kreiranje reda
	key = ftok("./sredinica.c", 123);
	if(key == -1)
	{
		perror("Nije moguce generisati jedinstveni kljuc\n");
		exit(0);
	}
	
	id_reda = msgget(key, IPC_CREAT|0666);
	if(id_reda == -1)
	{
		perror("Nije moguce generisati red za poruke\n");
		exit(0);
	}
	//kraj kreiranja reda
	
	pid1 = getpid();
	pid2 = fork();
	
	if(!pid2) //ukoliko je DETE 1
	{
		rbr = 2;
		int id_reda;
		key_t key;
		
		//kreiranje reda
		key = ftok("./sredinica.c", 123);
		if(key == -1)
		{
			perror("Nije moguce generisati jedinstveni kljuc\n");
			exit(0);
		}
		
		id_reda = msgget(key, IPC_CREAT|0666);
		if(id_reda == -1)
		{
			perror("Nije moguce generisati red za poruke\n");
			exit(0);
		}
		//kraj kreiranja reda
		
		pid3 = fork();
		
		if(pid3 == -1)
		{
			perror("Nije moguce kreirati novi proces\n");
			exit(0);
		}
		if(!pid3) //DETE proces 2
		{
			rbr = 3;
			int id_reda;
			key_t key;
			struct poruka por1, por2;
			
			//kreiranje reda
			key = ftok("./sredinica.c", 123);
			if(key == -1)
			{
				perror("Nije moguce generisati jedinstveni kljuc\n");
				exit(0);
			}
			
			id_reda = msgget(key, IPC_CREAT|0666);
			if(id_reda == -1)
			{
				perror("Nije moguce generisati red za poruke\n");
				exit(0);
			}
			//kraj kreiranja reda
			
			por1.tip = 2;
			por2.tip = 1;
			strcpy(por1.tekst, "Zdravo, ja sam dete 2\n");
			
			while(naRedu == 1)
			{
				printf("rbr %d: Cekam poruku tipa: %ld\n", rbr, por2.tip);
				if((msgrcv(id_reda, &por2, sizeof(por2.tekst), 1, 0)) == -1)
				{
					perror("Nije moguce primiti poruku");
					exit(0);
				}
				
				sleep(3);
				
				printf("rbr %d: Primio poruku tipa %ld tekst: %s\n", rbr, por2.tip, por2.tekst);
				
				sleep(3);
				
				printf("rbr %d: Saljem poruku tipa: %ld, tekst: %s\n", rbr, por1.tip, por1.tekst);
				if((msgsnd(id_reda, &por1, sizeof(por1.tekst), 0) == -1))
				{
					perror("Nije moguce poslati poruku\n");
					exit(0);
				}
				sleep(3);
			}
			
			while(1)
			{
				while(naRedu == 1)
				{
					por2.tip = 1;
					
					sleep(3);
					printf("rbr %d: Saljem poruku tipa: %ld, tekst: %s\n", rbr, por1.tip, por1.tekst);
					if((msgsnd(id_reda, &por1, sizeof(por1.tekst), 0)) == -1)
					{
						perror("Nije moguce poslati poruku\n");
						exit(0);
					}
					
					sleep(3);
									
					printf("rbr %d: Cekam poruku tipa: %ld\n", rbr, por2.tip);
					if((msgrcv(id_reda, &por2, sizeof(por2.tekst), 2, 0)) == -1)
					{
						perror("Nije moguce primiti poruku");
						exit(0);
					}
					
					sleep(3);
					
					printf("rbr %d: Primio poruku tipa %ld tekst: %s\n", rbr, por2.tip, por2.tekst);
					
					sleep(3);
				}
				
				while(naRedu == 2)
				{
					por2.tip = 3;
					
					sleep(3);
					printf("rbr %d: Saljem poruku tipa: %ld, tekst: %s\n", rbr, por1.tip, por1.tekst);
					if((msgsnd(id_reda, &por1, sizeof(por1.tekst), 0)) == -1)
					{
						perror("Nije moguce poslati poruku\n");
						exit(0);
					}
					
					sleep(3);
									
					printf("rbr %d: Cekam poruku tipa: %ld\n", rbr, por2.tip);
					if((msgrcv(id_reda, &por2, sizeof(por2.tekst), 2, 0)) == -1)
					{
						perror("Nije moguce primiti poruku");
						exit(0);
					}
					
					sleep(3);
					
					printf("rbr %d: Primio poruku tipa %ld tekst: %s\n", rbr, por2.tip, por2.tekst);
					
					sleep(3);
				}
				
				if(naRedu == rbr)
				{
					struct poruka por;
					srand(time(NULL));
					int flg;
					int r = rand() % 10 + 1;
					por.tip = r;
					
					flg = msgrcv(id_reda, &por, sizeof(por.tekst), r, IPC_NOWAIT);
			
					while(flg == -1)
					{
						r = rand() % 10 + 1;
						por.tip = r;
						
						printf("R je sad: %d\n", r);
						
						printf("rbr %d: Cekam poruku tipa: %ld\n", rbr, por.tip);
						
						flg = msgrcv(id_reda, &por, sizeof(por.tekst), r, IPC_NOWAIT);
						sleep(3);
					}
							
						printf("rbr %d: Primio poruku tipa: %ld tekst: %s\n", rbr, por.tip, por.tekst);
							
						kill(SIGCHLD, pid1);
					}
					else if(por.tip == 2)
					{
						naRedu = 0;
							
						printf("rbr %d: Primio poruku tipa: %ld tekst: %s\n", rbr, por.tip, por.tekst);
							
						kill(SIGCHLD, pid3);
					}
				}
			}
		}
		else //DETE proces 1
		{
			struct poruka por1, por2;
			
			por1.tip = 1;
			por2.tip = 2;
			strcpy(por1.tekst, "Zdravo, ja sam dete 1\n");
			
			while(naRedu == 1)
			{
				sleep(3);
				printf("rbr %d: Saljem poruku tipa: %ld, tekst: %s\n", rbr, por1.tip, por1.tekst);
				if((msgsnd(id_reda, &por1, sizeof(por1.tekst), 0)) == -1)
				{
					perror("Nije moguce poslati poruku\n");
					exit(0);
				}
				
				sleep(3);
								
				printf("rbr %d: Cekam poruku tipa: %ld\n", rbr, por2.tip);
				if((msgrcv(id_reda, &por2, sizeof(por2.tekst), 2, 0)) == -1)
				{
					perror("Nije moguce primiti poruku");
					exit(0);
				}
				
				sleep(3);
				
				printf("rbr %d: Primio poruku tipa %ld tekst: %s\n", rbr, por2.tip, por2.tekst);
				
				sleep(3);
			}
			
			while(1)
			{
				while(naRedu == 1)
				{
					por2.tip = 2;
					
					sleep(3);
					printf("rbr %d: Saljem poruku tipa: %ld, tekst: %s\n", rbr, por1.tip, por1.tekst);
					if((msgsnd(id_reda, &por1, sizeof(por1.tekst), 0)) == -1)
					{
						perror("Nije moguce poslati poruku\n");
						exit(0);
					}
					
					sleep(3);
									
					printf("rbr %d: Cekam poruku tipa: %ld\n", rbr, por2.tip);
					if((msgrcv(id_reda, &por2, sizeof(por2.tekst), 2, 0)) == -1)
					{
						perror("Nije moguce primiti poruku");
						exit(0);
					}
					
					sleep(3);
					
					printf("rbr %d: Primio poruku tipa %ld tekst: %s\n", rbr, por2.tip, por2.tekst);
					
					sleep(3);
				}
				
				while(naRedu == 3)
				{
					por2.tip = 3;
					
					sleep(3);
					printf("rbr %d: Saljem poruku tipa: %ld, tekst: %s\n", rbr, por1.tip, por1.tekst);
					if((msgsnd(id_reda, &por1, sizeof(por1.tekst), 0)) == -1)
					{
						perror("Nije moguce poslati poruku\n");
						exit(0);
					}
					
					sleep(3);
									
					printf("rbr %d: Cekam poruku tipa: %ld\n", rbr, por2.tip);
					if((msgrcv(id_reda, &por2, sizeof(por2.tekst), 2, 0)) == -1)
					{
						perror("Nije moguce primiti poruku");
						exit(0);
					}
					
					sleep(3);
					
					printf("rbr %d: Primio poruku tipa %ld tekst: %s\n", rbr, por2.tip, por2.tekst);
					
					sleep(3);
				}
				
				if(naRedu == rbr)
				{
					struct poruka por;
					srand(time(NULL));
					int flg;
					int r = rand() % 10 + 1;
					por.tip = r;
					
					flg = msgrcv(id_reda, &por, sizeof(por.tekst), r, IPC_NOWAIT);
			
					while(flg == -1)
					{
						r = rand() % 10 + 1;
						por.tip = r;
						
						printf("R je sad: %d\n", r);
						
						printf("rbr %d: Cekam poruku tipa: %ld\n", rbr, por.tip);
						
						flg = msgrcv(id_reda, &por, sizeof(por.tekst), r, IPC_NOWAIT);
						sleep(3);
					}
							
						printf("rbr %d: Primio poruku tipa: %ld tekst: %s\n", rbr, por.tip, por.tekst);
							
						kill(SIGCHLD, pid1);
					}
					else if(por.tip == 2)
					{
						naRedu = 0;
							
						printf("rbr %d: Primio poruku tipa: %ld tekst: %s\n", rbr, por.tip, por.tekst);
							
						kill(SIGCHLD, pid3);
					}
				}
			}	
					if(por.tip == 3)
					{
						naRedu = 0;
							
						printf("rbr %d: Primio poruku tipa: %ld tekst: %s\n", rbr, por.tip, por.tekst);
							
						kill(SIGCHLD, pid1);
					}
					else if(por.tip == 2)
					{
						naRedu = 0;
							
						printf("rbr %d: Primio poruku tipa: %ld tekst: %s\n", rbr, por.tip, por.tekst);
							
						kill(SIGCHLD, pid3);
					}
				}
			}
		}
	}
	else if(pid2 == -1)
	{
		perror("Nije moguce kreirati novi proces\n");
		exit(0);
	}
	else //proces RODITELJ
	{
		rbr = 1;
		struct poruka por;
		srand(time(NULL));
		int flg;
		int r = rand() % 10 + 1;
		por.tip = r;
		naRedu = 1;
		
		flg = msgrcv(id_reda, &por, sizeof(por.tekst), r, IPC_NOWAIT);
		
		while(flg == -1)
		{
			r = rand() % 10 + 1;
			por.tip = r;
			
			printf("R je sad: %d\n", r);
			
			printf("rbr %d: Cekam poruku tipa: %ld\n", rbr, por.tip);
			
			flg = msgrcv(id_reda, &por, sizeof(por.tekst), r, IPC_NOWAIT);
			sleep(3);
		}
		
		if(por.tip == 1)
		{
			naRedu = 0;
				
			printf("rbr %d: Primio poruku tipa: %ld tekst: %s\n", rbr, por.tip, por.tekst);
				
			kill(SIGCHLD, pid2);
		}
		else if(por.tip == 2)
		{
			naRedu = 0;
				
			printf("rbr %d: Primio poruku tipa: %ld tekst: %s\n", rbr, por.tip, por.tekst);
				
			kill(SIGCHLD, pid3);
		}
		
		while(1)
		{
			while(naRedu == 2)
			{
					por2.tip = 2;
					
					sleep(3);
					printf("rbr %d: Saljem poruku tipa: %ld, tekst: %s\n", rbr, por1.tip, por1.tekst);
					if((msgsnd(id_reda, &por1, sizeof(por1.tekst), 0)) == -1)
					{
						perror("Nije moguce poslati poruku\n");
						exit(0);
					}
					
					sleep(3);
									
					printf("rbr %d: Cekam poruku tipa: %ld\n", rbr, por2.tip);
					if((msgrcv(id_reda, &por2, sizeof(por2.tekst), 2, 0)) == -1)
					{
						perror("Nije moguce primiti poruku");
						exit(0);
					}
					
					sleep(3);
					
					printf("rbr %d: Primio poruku tipa %ld tekst: %s\n", rbr, por2.tip, por2.tekst);
					
					sleep(3);
				}
				
				while(naRedu == 3)
				{
					por2.tip = 1;
					
					sleep(3);
					printf("rbr %d: Saljem poruku tipa: %ld, tekst: %s\n", rbr, por1.tip, por1.tekst);
					if((msgsnd(id_reda, &por1, sizeof(por1.tekst), 0)) == -1)
					{
						perror("Nije moguce poslati poruku\n");
						exit(0);
					}
					
					sleep(3);
									
					printf("rbr %d: Cekam poruku tipa: %ld\n", rbr, por2.tip);
					if((msgrcv(id_reda, &por2, sizeof(por2.tekst), 2, 0)) == -1)
					{
						perror("Nije moguce primiti poruku");
						exit(0);
					}
					
					sleep(3);
					
					printf("rbr %d: Primio poruku tipa %ld tekst: %s\n", rbr, por2.tip, por2.tekst);
					
					sleep(3);
				}
				
				if(naRedu == rbr)
				{
					struct poruka por;
					srand(time(NULL));
					int flg;
					int r = rand() % 10 + 1;
					por.tip = r;
					
					flg = msgrcv(id_reda, &por, sizeof(por.tekst), r, IPC_NOWAIT);
			
					while(flg == -1)
					{
						r = rand() % 10 + 1;
						por.tip = r;
						
						printf("R je sad: %d\n", r);
						
						printf("rbr %d: Cekam poruku tipa: %ld\n", rbr, por.tip);
						
						flg = msgrcv(id_reda, &por, sizeof(por.tekst), r, IPC_NOWAIT);
						sleep(3);
					}
							
						printf("rbr %d: Primio poruku tipa: %ld tekst: %s\n", rbr, por.tip, por.tekst);
							
						kill(SIGCHLD, pid1);
					}
					else if(por.tip == 2)
					{
						naRedu = 0;
							
						printf("rbr %d: Primio poruku tipa: %ld tekst: %s\n", rbr, por.tip, por.tekst);
							
						kill(SIGCHLD, pid3);
					}
				}
			}
	}
	
	msgctl(id_reda, IPC_RMID, NULL);
	
	return 0;
}

/*
 * 1: tip 3
 * 2: tip 1
 * 3: tip 2
 * */
