#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
/*
Napisati program kojim će se kreirati procesi roditelj i dete. Procesi, svaki za sebe,
generišu broj N na slučajan način. Procesi ispisuju sve brojeve od 1 do N tako što prvo ispišu da li je
proces roditelj ili dete a zatim sam broj. Nakon svakog ispisa staviti sleep(2).
Proces koji prvi završi sa ispisom, šalje signal SIGINT drugom procesu koji hvata taj signal I ispisuje
poruku :
a. Roditelj: Prekinuo me je process dete
b. Dete : Prekinuo me je process roditelj.
Nakon ispisane poruke, procesi završavaju sa radom.
*/

void handler_dete(int sig)
{
	printf("Prekinuo me je process roditelj\n");
	exit(1);
}

void handler_roditelj(int sig)
{
	printf("Prekinuo me je process dete\n");
	exit(1);
}

int main()
{
	int i,N;
	pid_t pid;
	pid=fork();
	
	if(pid)
	{
		signal(SIGINT,handler_roditelj);
		N=(rand()%20)+1;
		printf("RODITELJ ispisuje do %d\n",N);
		for(i=1;i<N;i++)
		{
			printf("RODITELJ %d\n",i);
			sleep(2);
		}
		kill(pid,SIGINT);
	}
	else
	{
		signal(SIGINT,handler_dete);
		N=(rand()%20)+1;
		printf("DETE ispisuje do %d\n",N);
		for(i=1;i<N;i++)
		{
			printf("DETE %d\n",i);
			sleep(2);
		}
		kill(getppid(),SIGINT);
	}
}
