#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <time.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

typedef struct _PORUKA{
    long tip;
    int rb;
    int brKlijenata;
    char tekst[100];
} _poruka;

int msgid;

void DeleteMSG(){
	msgctl(msgid, IPC_RMID, NULL);
}

void handler(int sig){
	DeleteMSG();
	exit(0);
}

int main(){
    key_t key;
    _poruka poruka;
    int pid;
    int rb;
    int nKlijenata;
    int randomKlijent;

	srand(time(0));
	signal(SIGINT, handler);

    key = ftok("./server.c", 1);
    msgid = msgget(key, IPC_CREAT|0666);

    pid = getpid();
    poruka.tip = pid;
    printf("Saljem poruku sa tipom %d\n", pid);
    msgsnd(msgid, &poruka, sizeof(poruka), 0);
    printf("Ocekujem poruku sa tipom %d i rednim brojem\n", pid);
    msgrcv(msgid, &poruka, sizeof(poruka), pid, 0);
    rb = poruka.rb;
    printf("Primio, tip %d, rb %d\n", pid, rb);
    
    printf("Ocekujem poruku sa tipom %d(rb) i brojem prijavljenih klijenata.\n", rb);
    msgrcv(msgid, &poruka, sizeof(poruka), rb, 0);
    printf("Primio, tip %ld, broj klijenata %d\n", poruka.tip, poruka.brKlijenata);
    nKlijenata = poruka.brKlijenata;
    
    printf("\n\n");
    while(1){
		printf("Ocekujem poruku sa tipom %d\n", rb);
		msgrcv(msgid, &poruka, sizeof(poruka), rb, 0);
		printf("Primio, tip %ld, sadrzaj: %s\n", poruka.tip, poruka.tekst);
		
		printf("Unesite poruku za slanje: ");
		scanf("%s", poruka.tekst);
		
		while((randomKlijent = rand() % nKlijenata + 1) == rb);
		poruka.tip = randomKlijent;
		
		printf("Saljem poruku sa tipom %ld, sadrzaj %s\n", poruka.tip, poruka.tekst);
		msgsnd(msgid, &poruka, sizeof(poruka), 0);
	}
    

    return 0;
}
